## bacula 9.6.7

=== src/win32/cats/Makefile ===
#
# Makefile for win32 bacula executables
# Using MinGW cross-compiler on GNU/Linux
#
#
# Author: Robert Nelson
# License: BSD 2-Clause; see file LICENSE-FOSS
#
#  Written by Robert Nelson, June 2006
#

include ../Makefile.inc

INCLUDES = \
	$(INCLUDE_PTHREADS) \
	$(INCLUDE_BACULA) \
	$(INCLUDE_ZLIB) \
	$(INCLUDE_OPENSSL) \
	$(INCLUDE_MYSQL)

DEFINES = \
	$(HAVES)

vpath %.c $(MAINDIR)/src/cats
vpath %.cpp $(MAINDIR)/src/cats

######################################################################

# Files files in src/lib

SQL_OBJS = \
	sql.o \
	sql_cmds.o \
	sql_create.o \
	sql_delete.o \
	sql_find.o \
	sql_get.o \
	sql_glue.o \
	sql_list.o \
	sql_update.o \
	cats.o \
	bvfs.o

LIBS_DLL = \
	$(LIBS_BACULA)

######################################################################

# Targets

.PHONY: all clean

#all: $(LIBDIR)/libcats.a $(BINDIR)/cats_mysql.dll $(BINDIR)/cats_postgresql.dll $(BINDIR)/cats_sqlite3.dll
all: $(LIBDIR)/libcats.a  $(BINDIR)/cats_postgresql.dll

clean:
	@echo "Cleaning `pwd`"
	$(call clean_obj,$(addprefix $(OBJDIR)/cats_mysql/,mysql.o $(SQL_OBJS)))
	$(call clean_obj,$(addprefix $(OBJDIR)/cats_postgresql/,postgresql.o $(SQL_OBJS)))
	$(call clean_obj,$(addprefix $(OBJDIR)/cats_sqlite3/,sqlite.o $(SQL_OBJS)))
	$(call clean_exe,$(BINDIR)/cats_mysql.dll)
	$(call clean_exe,$(BINDIR)/cats_postgresql.dll)
	$(call clean_exe,$(BINDIR)/cats_sqlite3.dll)
	$(ECHO_CMD)rm -f $(OBJDIR)/libcats.exp $(LIBDIR)/libcats.a
	$(ECHO_CMD)rm -rf $(OBJDIRS)

$(LIBDIR)/libcats.a $(OBJDIR)/libcats.exp: bacula_cats.def
	$(call checkdir,$@)
	@mkdir -p $(OBJDIRS)
	$(DLLTOOL) --dllname bacula_cats.dll --no-export-all-symbols --input-def bacula_cats.def --output-exp $(OBJDIR)/libcats.exp --output-lib $(LIBDIR)/libcats.a $^

$(BINDIR)/cats_mysql.dll: $(addprefix $(OBJDIR)/cats_mysql/,mysql.o $(SQL_OBJS)) $(OBJDIR)/libcats.exp
	@echo "Linking $@"
	$(call checkdir,$@)
	$(ECHO_CMD)$(CXX) $(LDFLAGS) -mdll -mwindows $^ $(LIBS_MYSQL) $(LIBS_DLL) -o $@

$(BINDIR)/cats_postgresql.dll: $(addprefix $(OBJDIR)/cats_postgresql/,postgresql.o $(SQL_OBJS)) $(OBJDIR)/libcats.exp
	@echo "Linking $@"
	$(call checkdir,$@)
	$(ECHO_CMD)$(CXX) $(LDFLAGS) -mdll -mwindows $^ $(LIBS_POSTGRESQL) $(LIBS_DLL) -o $@

$(BINDIR)/cats_sqlite3.dll: $(addprefix $(OBJDIR)/cats_sqlite3/,sqlite.o $(SQL_OBJS)) $(OBJDIR)/libcats.exp
	@echo "Linking $@"
	$(call checkdir,$@)
	$(ECHO_CMD)$(CXX) $(LDFLAGS) -mdll -mwindows $^ $(LIBS_SQLITE) $(LIBS_DLL) -o $@

#
# Rules for generating from ../cats
#

include ../Makefile.rules

define Link_Dll
$(OBJDIR)/$(1)/%.o: %.c
	@echo "Compiling $$<"
	$$(call checkdir,$$@)
	$(ECHO_CMD)$(CXX) -D_BDB_PRIV_INTERFACE_ -DBUILDING_CATS -DUSING_DLL -DHAVE_$(2) $(CFLAGS) -c $$< -o $$@

$(OBJDIR)/$(1)/%.o: %.cpp
	@echo "Compiling $$<"
	$$(call checkdir,$$@)
	$(ECHO_CMD)$(CXX) -D_BDB_PRIV_INTERFACE_ -DBUILDING_CATS -DUSING_DLL -DHAVE_$(2) $(CFLAGS) -c $$< -o $$@

endef

$(eval $(call Link_Dll,cats_mysql,MYSQL))

$(eval $(call Link_Dll,cats_postgresql,POSTGRESQL))

$(eval $(call Link_Dll,cats_sqlite3,SQLITE3))

=== src/win32/compat/Makefile ===
#
# Makefile for win32 bacula executables
# Using MinGW cross-compiler on GNU/Linux
#  
#
# Author: Howard Thomson
# License: BSD 2-Clause; see file LICENSE-FOSS
#
#  Written for Bacula by Howard Thomson, April 2006
# 

include ../Makefile.inc

INCLUDES = \
	$(INCLUDE_GCC) \
	$(INCLUDE_MINGW) \
	$(INCLUDE_PTHREADS) \
	$(INCLUDE_BACULA) \
	$(INCLUDE_ZLIB) \
	$(INCLUDE_VSS) \
	$(INCLUDE_ICONS) \
	$(INCLUDE_OPENSSL)

DEFINES = \
	-DWIN32 \
	$(HAVES)

######################################################################

# Files files in src/win32/compat

LIB_OBJS = \
	$(OBJDIR)/compat.o \
	$(OBJDIR)/getopt.o \
	$(OBJDIR)/print.o \
	$(OBJDIR)/vss.o \
	$(OBJDIR)/vss_XP.o \
	$(OBJDIR)/vss_W2K3.o \
	$(OBJDIR)/vss_Vista.o

######################################################################

# Targets

.PHONY: all clean

all: $(LIBDIR)/libcompat.a

clean:
	@echo "Cleaning `pwd`"
	$(ECHO_CMD)rm -f $(OBJDIR)/*.[od] $(LIBDIR)/libcompat.a

#
# Rules
# 

$(LIBDIR)/libcompat.a: $(LIB_OBJS)
	@echo "Updating archive $@"
	$(call checkdir,$@)
	$(ECHO_CMD)$(AR) rs $@ $^

include ../Makefile.rules

ifneq ($(MAKECMDGOALS),clean)
include $(patsubst %.o,%.d,$(filter-out %.res,$(LIB_OBJS)))
endif

=== src/win32/dird/Makefile ===
#
# Makefile for win32 bacula executables
# Using MinGW cross-compiler on GNU/Linux
#
#
# Author: Robert Nelson
# License: BSD 2-Clause; see file LICENSE-FOSS
#
#  Written by Robert Nelson, June 2006
#

include ../Makefile.inc

INCLUDES = \
	-I. \
	$(INCLUDE_PTHREADS) \
	$(INCLUDE_BACULA) \
	$(INCLUDE_ZLIB) \
	$(INCLUDE_OPENSSL) \
	$(INCLUDE_ICONS)

DEFINES = \
	-DUSING_DLL \
	-DUSING_CATS \
	-DWINVER=0x500 \
	$(HAVES)

vpath %.c $(MAINDIR)/src/dird $(BUILDDIR)/libwin32
vpath %.cpp $(MAINDIR)/src/dird $(BUILDDIR)/libwin32

##########################################################################

DIRD_OBJS = \
	$(OBJDIR)/admin.o \
	$(OBJDIR)/authenticate.o \
	$(OBJDIR)/autoprune.o \
	$(OBJDIR)/backup.o \
	$(OBJDIR)/bsr.o \
	$(OBJDIR)/catreq.o \
	$(OBJDIR)/dir_plugins.o \
	$(OBJDIR)/dird.o \
	$(OBJDIR)/dird_conf.o \
	$(OBJDIR)/expand.o \
	$(OBJDIR)/fd_cmds.o \
	$(OBJDIR)/getmsg.o \
	$(OBJDIR)/inc_conf.o \
	$(OBJDIR)/job.o \
	$(OBJDIR)/jobq.o \
	$(OBJDIR)/mountreq.o \
	$(OBJDIR)/msgchan.o \
	$(OBJDIR)/newvol.o \
	$(OBJDIR)/next_vol.o \
	$(OBJDIR)/recycle.o \
	$(OBJDIR)/restore.o \
	$(OBJDIR)/run_conf.o \
	$(OBJDIR)/scheduler.o \
	$(OBJDIR)/ua_acl.o \
	$(OBJDIR)/ua_cmds.o \
	$(OBJDIR)/ua_dotcmds.o \
	$(OBJDIR)/ua_collect.o \
	$(OBJDIR)/ua_input.o \
	$(OBJDIR)/ua_label.o \
	$(OBJDIR)/ua_output.o \
	$(OBJDIR)/ua_prune.o \
	$(OBJDIR)/ua_purge.o \
	$(OBJDIR)/ua_query.o \
	$(OBJDIR)/ua_restore.o \
	$(OBJDIR)/ua_run.o \
	$(OBJDIR)/ua_select.o \
	$(OBJDIR)/ua_server.o \
	$(OBJDIR)/ua_status.o \
	$(OBJDIR)/ua_tree.o \
	$(OBJDIR)/ua_update.o \
	$(OBJDIR)/ua_dde.o \
	$(OBJDIR)/vbackup.o \
	$(OBJDIR)/verify.o \
	$(OBJDIR)/service.o \
	$(OBJDIR)/mac_sql.o \
	$(OBJDIR)/mac.o \
	$(OBJDIR)/main.o \
	$(OBJDIR)/bacula.res

ALL_OBJS = $(DIRD_OBJS)


DIRD_LIBS = \
	$(LIBS_PTHREADS) \
	$(LIBS_NETWORK) \
	-lole32 \
	-loleaut32 \
	-luuid \
	-lcomctl32

######################################################################

# Targets

.PHONY: all clean

all: $(BINDIR)/bacula-dir.exe

clean:
	@echo "Cleaning `pwd`"
	$(call clean_obj,$(ALL_OBJS))
	$(call clean_exe,$(BINDIR)/bacula-dir.exe)
	$(ECHO_CMD)rm -rf $(OBJDIRS)

#
# Rules
#

$(BINDIR)/bacula-dir.exe: $(DIRD_OBJS) $(LIBS_CATS) $(LIBS_BACULA)
	$(call link_winapp,$(DIRD_LIBS))

$(OBJDIR)/winres.res: winres.rc
	$(WINDRES) $(INCLUDE_ICONS) -O coff $< -o $@

include ../Makefile.rules

=== src/win32/filed/Makefile ===
#
# Makefile for win32 bacula executables
# Using MinGW cross-compiler on GNU/Linux
#
# Author: Robert Nelson
# License: BSD 2-Clause; see file LICENSE-FOSS
#
#  Written by Robert Nelson, June 2006
#

#
# Change the following depending on where this directory is located
#  in the Bacula tree.	It should point to the src/win32 directory.
BUILDDIR = ..


include $(BUILDDIR)/Makefile.inc

INCLUDES = \
	-I. \
	$(INCLUDE_PTHREADS) \
	$(INCLUDE_BACULA) \
	$(INCLUDE_ZLIB) \
	$(INCLUDE_VSS) \
	$(INCLUDE_OPENSSL) \
	$(INCLUDE_ICONS)

DEFINES = \
	-DUSING_DLL \
	-DWIN32_VSS \
	-DWINVER=0x500 \
	$(HAVES)

#	-DHAVE_TRAY_MONITOR \


vpath %.c $(MAINDIR)/src/filed $(BUILDDIR)/libwin32
vpath %.cpp $(MAINDIR)/src/filed $(BUILDDIR)/libwin32

##########################################################################

FILED_OBJS = \
	$(OBJDIR)/accurate.o \
	$(OBJDIR)/authenticate.o \
	$(OBJDIR)/backup.o \
	$(OBJDIR)/crypto.o \
	$(OBJDIR)/fdcollect.o \
	$(OBJDIR)/win_efs.o \
	$(OBJDIR)/estimate.o \
	$(OBJDIR)/fd_plugins.o \
	$(OBJDIR)/fd_snapshot.o \
	$(OBJDIR)/filed.o \
	$(OBJDIR)/filed_conf.o \
	$(OBJDIR)/heartbeat.o \
	$(OBJDIR)/hello.o \
	$(OBJDIR)/job.o \
	$(OBJDIR)/restore.o \
	$(OBJDIR)/status.o \
	$(OBJDIR)/verify.o \
	$(OBJDIR)/verify_vol.o \
	$(OBJDIR)/vss.o \
	$(OBJDIR)/vss_XP.o \
	$(OBJDIR)/vss_W2K3.o \
	$(OBJDIR)/vss_Vista.o \
	$(OBJDIR)/service.o \
	$(OBJDIR)/main.o \
	$(OBJDIR)/bacl.o \
	$(OBJDIR)/bacl_linux.o \
	$(OBJDIR)/bacl_solaris.o \
	$(OBJDIR)/bxattr_freebsd.o \
	$(OBJDIR)/bxattr_osx.o \
	$(OBJDIR)/bacl_freebsd.o \
	$(OBJDIR)/bacl_osx.o \
	$(OBJDIR)/bxattr.o \
	$(OBJDIR)/bxattr_linux.o \
	$(OBJDIR)/bxattr_solaris.o \
	$(OBJDIR)/suspend.o \
	$(OBJDIR)/bacula.res

#	$(OBJDIR)/trayMonitor.o \
#	$(OBJDIR)/aboutDialog.o \
#	$(OBJDIR)/statusDialog.o \


ALL_OBJS = $(FILED_OBJS)

FILED_LIBS = \
	$(LIBS_PTHREADS) \
	$(LIBS_ZLIB) \
	$(LIBS_LZO) \
	$(LIBS_NETWORK) \
	-lole32 \
	-loleaut32 \
	-luuid \
	-lcomctl32

######################################################################

# Targets

.PHONY: all clean distclean

all: $(BINDIR)/bacula-fd.exe

distclean: clean

clean:
	@echo "Cleaning `pwd`"
	$(call clean_obj,$(ALL_OBJS))
	$(call clean_exe,$(BINDIR)/bacula-fd.exe)
	$(ECHO_CMD)rm -rf $(OBJDIRS)

#
# Rules
#

$(BINDIR)/bacula-fd.exe: $(FILED_OBJS) $(LIBS_BACULA)
	$(call link_winapp,$(FILED_LIBS))

$(OBJDIR)/winres.res: $(BUILDDIR)/libwin32/winres.rc
	@echo "Compiling $@"
	$(call checkdir,$@)
	$(ECHO_CMD)$(WINDRES) $(INCLUDE_ICONS) -DMINGW64 -O coff $< -o $@

include $(BUILDDIR)/Makefile.rules

=== src/win32/lib/Makefile ===
#
# Copyright (C) 2000-2018 Kern Sibbald
# License: BSD 2-Clause; see file LICENSE-FOSS
#
#
# Makefile for win32 bacula executables
# Using MinGW cross-compiler on GNU/Linux
#
#  Written by Robert Nelson, June 2006
#

include ../Makefile.inc

INCLUDES = \
	$(INCLUDE_PTHREADS) \
	$(INCLUDE_BACULA) \
	$(INCLUDE_ZLIB) \
	$(INCLUDE_OPENSSL)

DEFINES = \
	$(HAVES)

vpath %.c $(BUILDDIR)/compat $(MAINDIR)/src/findlib $(MAINDIR)/src/lib
vpath %.cpp $(BUILDDIR)/compat $(MAINDIR)/src/findlib $(MAINDIR)/src/lib

######################################################################

# Files files in src/lib

COMPAT_OBJS = \
	$(OBJDIR)/compat.o \
	$(OBJDIR)/print.o \
	$(OBJDIR)/winapi.o

#	$(OBJDIR)/getopt.o \

FIND_OBJS = \
	$(OBJDIR)/attribs.o \
	$(OBJDIR)/bfile.o \
	$(OBJDIR)/win32filter.o \
	$(OBJDIR)/create_file.o \
	$(OBJDIR)/drivetype.o \
	$(OBJDIR)/enable_priv.o \
	$(OBJDIR)/find.o \
	$(OBJDIR)/find_one.o \
	$(OBJDIR)/fstype.o \
	$(OBJDIR)/mkpath.o \
	$(OBJDIR)/match.o

LIB_OBJS = \
	$(OBJDIR)/address_conf.o \
	$(OBJDIR)/alist.o \
	$(OBJDIR)/attr.o \
	$(OBJDIR)/base64.o \
	$(OBJDIR)/berrno.o \
	$(OBJDIR)/bget_msg.o \
	$(OBJDIR)/bnet.o \
	$(OBJDIR)/bnet_server.o \
	$(OBJDIR)/bpipe.o \
	$(OBJDIR)/breg.o \
	$(OBJDIR)/bregex.o \
	$(OBJDIR)/bsock.o \
	$(OBJDIR)/bsockcore.o \
	$(OBJDIR)/bstat.o \
	$(OBJDIR)/bcollector.o \
	$(OBJDIR)/collect.o \
	$(OBJDIR)/bsnprintf.o \
	$(OBJDIR)/bsys.o \
	$(OBJDIR)/btime.o \
	$(OBJDIR)/btimers.o \
	$(OBJDIR)/cram-md5.o \
	$(OBJDIR)/crc32.o \
	$(OBJDIR)/crypto.o \
	$(OBJDIR)/daemon.o \
	$(OBJDIR)/dlist.o \
	$(OBJDIR)/edit.o \
	$(OBJDIR)/fnmatch.o \
	$(OBJDIR)/guid_to_name.o \
	$(OBJDIR)/hmac.o \
	$(OBJDIR)/htable.o \
	$(OBJDIR)/jcr.o \
	$(OBJDIR)/lex.o \
	$(OBJDIR)/lz4.o \
	$(OBJDIR)/md5.o \
	$(OBJDIR)/mem_pool.o \
	$(OBJDIR)/message.o \
	$(OBJDIR)/openssl.o \
	$(OBJDIR)/plugins.o \
	$(OBJDIR)/priv.o \
	$(OBJDIR)/queue.o \
	$(OBJDIR)/rblist.o \
	$(OBJDIR)/runscript.o \
	$(OBJDIR)/rwlock.o \
	$(OBJDIR)/scan.o \
	$(OBJDIR)/serial.o \
	$(OBJDIR)/sha1.o \
	$(OBJDIR)/signal.o \
	$(OBJDIR)/smartall.o \
	$(OBJDIR)/tls.o \
	$(OBJDIR)/tree.o \
	$(OBJDIR)/util.o \
	$(OBJDIR)/var.o \
	$(OBJDIR)/watchdog.o \
	$(OBJDIR)/workq.o \
	$(OBJDIR)/binflate.o \
	$(OBJDIR)/ini.o \
	$(OBJDIR)/output.o \
	$(OBJDIR)/sellist.o \
	$(OBJDIR)/lockmgr.o \
	$(OBJDIR)/worker.o \
	$(OBJDIR)/flist.o

DLL_OBJS = \
	$(COMPAT_OBJS) $(FIND_OBJS) $(LIB_OBJS)

STATIC_OBJS = \
	$(OBJDIR)/parse_conf.o \
	$(OBJDIR)/res.o

ALL_OBJS = \
	$(DLL_OBJS) $(STATIC_OBJS)

LIBS_DLL = \
	$(LIBS_SSL) \
	$(LIBS_CRYPTO) \
	$(LIBS_PTHREADS) \
	$(LIBS_ZLIB) \
	$(LIBS_NETWORK) \
	-lole32 \
	-loleaut32 \
	-lws2_32 \
	-luuid

######################################################################

# Targets

.PHONY: all clean distclean

all: $(BINDIR)/bacula.dll $(LIBDIR)/libbacula.a

distclean: clean

clean:
	@echo "Cleaning `pwd`"
	$(call clean_obj,$(ALL_OBJS))
	$(call clean_exe,$(BINDIR)/bacula.dll)
	$(ECHO_CMD)rm -f $(OBJDIR)/bacula.a $(LIBDIR)/libbacula.a
	$(ECHO_CMD)rm -rf $(OBJDIRS)

#
# Rules for generating from ../lib
#

$(LIBDIR)/libbacula.a: DLL_DEFINE=USING_DLL

$(LIBDIR)/libbacula.a: $(BINDIR)/bacula.dll $(STATIC_OBJS)
	@echo "Updating archive $@"
	$(call checkdir,$@)
	$(ECHO_CMD)cp $(OBJDIR)/bacula.a $@
	$(ECHO_CMD)$(AR) rsv $@ $(filter %.o,$^)

$(BINDIR)/bacula.dll: DLL_DEFINE=BUILDING_DLL

$(BINDIR)/bacula.dll: $(DLL_OBJS) bacula$(WIN_VERSION).def
	@echo "Linking $@"
	$(call checkdir,$@)
	$(ECHO_CMD)$(CXX) $(LDFLAGS) -mdll -mwindows -Wl,--out-implib,$(OBJDIR)/bacula.a $^ $(LIBS_DLL) -o $@

bacula$(WIN_VERSION).def: $(DLL_OBJS)
	./make_def$(WIN_VERSION) $(DLL_OBJS) >bacula$(WIN_VERSION).def.new && \
	  mv bacula$(WIN_VERSION).def.new bacula$(WIN_VERSION).def


include ../Makefile.rules

$(OBJDIR)/%.o: %.c
	@echo "Compiling $<"
	$(call checkdir,$@)
	$(ECHO_CMD)$(CXX) -D$(DLL_DEFINE) $(CFLAGS) -c $< -o $@

$(OBJDIR)/%.o: %.cpp
	@echo "Compiling $<"
	$(call checkdir,$@)
	$(ECHO_CMD)$(CXX) -D$(DLL_DEFINE) $(CFLAGS) -c $< -o $@

=== src/win32/stored/Makefile ===
#
# Makefile for win32 bacula executables
# Using MinGW cross-compiler on GNU/Linux
#
#
# Author: Robert Nelson
# License: BSD 2-Clause; see file LICENSE-FOSS
#
#  Written by Robert Nelson, June 2006
#

# Configuration

include ../Makefile.inc

INCLUDES = \
	-I. \
	-I$(MAINDIR)/src/stored \
	$(INCLUDE_DDK) \
	$(INCLUDE_PTHREADS) \
	$(INCLUDE_BACULA) \
	$(INCLUDE_ZLIB) \
	$(INCLUDE_OPENSSL) \
	$(INCLUDE_ICONS)

DEFINES = \
	-DUSING_DLL \
	-DWINVER=0x500 \
	$(HAVES)

#	-DHAVE_TRAY_MONITOR \


vpath %.c $(MAINDIR)/src/stored $(BUILDDIR)/libwin32
vpath %.cpp $(MAINDIR)/src/stored $(BUILDDIR)/libwin32

##########################################################################

COMMON_OBJS = \
	$(OBJDIR)/askdir.o \
	$(OBJDIR)/tape_alert.o \
	$(OBJDIR)/tape_worm.o \
	$(OBJDIR)/vtape_dev.o \
	$(OBJDIR)/tape_dev.o \
	$(OBJDIR)/init_dev.o \
	$(OBJDIR)/global.o \
	$(OBJDIR)/acquire.o \
	$(OBJDIR)/aligned_dev.o \
	$(OBJDIR)/aligned_read.o \
	$(OBJDIR)/aligned_write.o \
	$(OBJDIR)/ansi_label.o \
	$(OBJDIR)/authenticate.o \
	$(OBJDIR)/autochanger.o \
	$(OBJDIR)/block.o \
	$(OBJDIR)/block_util.o \
	$(OBJDIR)/butil.o \
	$(OBJDIR)/dev.o \
	$(OBJDIR)/device.o \
	$(OBJDIR)/ebcdic.o \
	$(OBJDIR)/hello.o \
	$(OBJDIR)/label.o \
	$(OBJDIR)/lock.o \
	$(OBJDIR)/match_bsr.o \
	$(OBJDIR)/mount.o \
	$(OBJDIR)/parse_bsr.o \
	$(OBJDIR)/read_records.o \
	$(OBJDIR)/record_read.o \
	$(OBJDIR)/record_util.o \
	$(OBJDIR)/record_write.o \
	$(OBJDIR)/reserve.o \
	$(OBJDIR)/scan.o \
	$(OBJDIR)/spool.o \
	$(OBJDIR)/stored_conf.o \
	$(OBJDIR)/vol_mgr.o \
	$(OBJDIR)/wait.o \
	$(OBJDIR)/file_dev.o \
	$(OBJDIR)/sd_plugins.o \
	$(OBJDIR)/os.o



#	 $(OBJDIR)/mtops.o

# bacula-sd
SD_OBJS = \
	$(OBJDIR)/sdcollect.o \
	$(OBJDIR)/stored.o \
	$(OBJDIR)/append.o \
	$(OBJDIR)/dircmd.o \
	$(OBJDIR)/fd_cmds.o \
	$(OBJDIR)/job.o \
	$(OBJDIR)/read.o \
	$(OBJDIR)/vbackup.o \
	$(OBJDIR)/status.o

# bextract
BEXTRACT_OBJS = \
	$(OBJDIR)/bextract.o 

OBJS_WIN = \
	$(OBJDIR)/service.o \
	$(OBJDIR)/main.o \
	$(OBJDIR)/bacula.res

#	$(OBJDIR)/trayMonitor.o \
#	$(OBJDIR)/aboutDialog.o \
#	$(OBJDIR)/statusDialog.o \


ALL_OBJS = \
	$(COMMON_OBJS) \
	$(SD_OBJS) \
	$(BEXTRACT_OBJS) \
	$(OBJS_WIN) \
	$(OBJDIR)/bcopy.o \
	$(OBJDIR)/bls.o \
	$(OBJDIR)/btape.o \
	$(OBJDIR)/bscan.o

LIBS_STORED = \
	$(LIBS_PTHREADS) \
	$(LIBS_NETWORK) \
	-lole32 \
	-loleaut32 \
	-luuid \
	-lcomctl32

######################################################################

# Targets

.PHONY: all clean

all:	$(BINDIR)/bacula-sd.exe  $(BINDIR)/bcopy.exe $(BINDIR)/bextract.exe  $(BINDIR)/bls.exe 
# $(BINDIR)/bscan.exe $(BINDIR)/btape.exe

clean:
	@echo "Cleaning `pwd`"
	$(call clean_obj,$(ALL_OBJS))
	$(call clean_exe,$(BINDIR)/bacula-sd.exe)
	$(call clean_exe,$(BINDIR)/bcopy.exe)
	$(call clean_exe,$(BINDIR)/bextract.exe)
	$(call clean_exe,$(BINDIR)/bls.exe)
	$(call clean_exe,$(BINDIR)/bscan.exe)
	$(call clean_exe,$(BINDIR)/btape.exe)
	$(ECHO_CMD)rm -rf $(OBJDIRS)

realclean: clean
	rm -f tags bacula-sd.conf

#
# Rules
#

$(BINDIR)/bacula-sd.exe: $(SD_OBJS) $(COMMON_OBJS) $(OBJS_WIN) $(LIBS_BACULA)
	$(call link_winapp,$(LIBS_STORED))

$(BINDIR)/btape.exe: $(OBJDIR)/btape.o $(COMMON_OBJS) $(LIBS_BACULA)
	$(call link_conapp,$(LIBS_STORED))

$(BINDIR)/bls.exe: $(OBJDIR)/bls.o $(COMMON_OBJS) $(LIBS_BACULA)
	$(call link_conapp,$(LIBS_STORED))

$(BINDIR)/bextract.exe: $(BEXTRACT_OBJS) $(COMMON_OBJS) $(LIBS_BACULA) $(LIBS_LZO)
	$(call link_conapp,$(LIBS_STORED) $(LIBS_ZLIB))

$(BINDIR)/bscan.exe: $(OBJDIR)/bscan.o $(COMMON_OBJS) $(LIBS_CATS) $(LIBS_BACULA)
	$(call link_conapp,$(LIBS_STORED))

$(BINDIR)/bcopy.exe: $(OBJDIR)/bcopy.o $(COMMON_OBJS) $(LIBS_BACULA)
	$(call link_conapp,$(LIBS_STORED))

$(OBJDIR)/mtops.o: mtops.cpp
	@echo "Compiling $@"
	$(call checkdir,$@)
	$(ECHO_CMD)$(CXX) $(CFLAGS) $(INCLUDE_DDK) -I../../stored -c $< -o $@

$(OBJDIR)/winres.res:	  baculasd/winres.rc
	@echo "Compiling $@"
	$(call checkdir,$@)
	$(ECHO_CMD)$(WINDRES) $(INCLUDE_ICONS) -I baculasd -O coff $< -o $@

include ../Makefile.rules

=== src/win32/win32_installer/Makefile ===
#
# Copyright (C) 2000-2018 Kern Sibbald
# License: BSD 2-Clause; see file LICENSE-FOSS
#
#
# Makefile for win32 bacula executables
# Using MinGW cross-compiler on GNU/Linux
#
#  Written by Robert Nelson, June 2006
#

include ../Makefile.inc

VERSION := $(shell sed -ne 's/^.define[ \t]VERSION[ \t][ \t]*"\(.*\)"/\1/p' < ../../version.h)
RELEASE ?= $(shell awk '/define RELEASE [0-9]+/ { print $$3 }' ../../version.h)

DEFINES := \
	-DVERSION=$(VERSION) \
	-DOUT_DIR=$(BUILDDIR)/release32 \
	-DSRC_DIR=release32 \
	-DBUILD_TOOLS=MinGW32 \
	-DWINVER=32 \
	-DBUILD_BAT=$(BUILD_BAT)

INSTALL_EXE := $(BUILDDIR)/release32/winbacula-$(VERSION).exe

BACULABINARIES := \
	bacula.dll \
	alldrives-fd.dll \
	exchange-fd.dll \
	bacula-fd.exe \
	bconsole.exe \
	bsleep.exe \
	bsmtp.exe \
	bacula-sd.exe \
	bextract.exe \
	bls.exe \
	bcopy.exe

ifeq ($(bat),no)
	BACULA_BINARIES=$(BACULABINARIES)
	HELP=
else
	BACULA_BINARIES=$(BACULABINARIES) bat.exe bacula-tray-monitor.exe
	HELP=help
endif

EXTRA=

#	bacula-sd.exe \


DEPKGS_BINARIES := \
	libeay32.dll \
	pthreadGCE2.dll \
	zlib1.dll \
	ssleay32.dll \
	openssl.exe \
	sed.exe \
	expr64.exe \
	snooze.exe \
	QtCore4.dll \
	QtGui4.dll  \
	libwinpthread-1.dll \
	libgcc_s_sjlj-1.dll \
	libstdc++-6.dll
#	libgcc_s_dw2-1.dll


NONGCC_BINARIES := 

NONGCC_LIBRARIES := 

MINGW_BINARIES := 

SCRIPT_FILES := 

CAT_FILES := 

DIRD_FILES := 

SSL_FILES := \
	openssl.cnf

LICENSE_FILES := \
	LICENSE

##########################################################################

# Targets

.PHONY: all clean installer distclean

all:	      $(HELP) docs $(INSTALL_EXE) $(EXTRA)

installer:    $(HELP) docs $(INSTALL_EXE)

distclean: clean

clean:
	@echo "Cleaning `pwd`"
	$(CMD_ECHO)-rm -f $(INSTALL_EXE)
	$(CMD_ECHO)-rm -rf release32

help:
	rm -rf release32/help
	mkdir -p release32/help
	cp -f $(BINDIR)/help/* release32/help/

docs:
	rm -rf release32/docs
	mkdir -p release32/docs/manuals/en/console
	mkdir -p release32/docs/manuals/en/main
	mkdir -p release32/docs/manuals/en/misc
	mkdir -p release32/docs/manuals/en/problems
	mkdir -p release32/docs/manuals/en/utility
	cp -f $(DOCDIR)/docs/manuals/en/pdf-and-html/console/console.pdf release32/docs/manuals/en/console/
	cp -f $(DOCDIR)/docs/manuals/en/pdf-and-html/main/main.pdf release32/docs/manuals/en/main/
	cp -f $(DOCDIR)/docs/manuals/en/pdf-and-html/misc/misc.pdf release32/docs/manuals/en/misc/
	cp -f $(DOCDIR)/docs/manuals/en/pdf-and-html/problems/problems.pdf release32/docs/manuals/en/problems/
	cp -f $(DOCDIR)/docs/manuals/en/pdf-and-html/utility/utility.pdf release32/docs/manuals/en/utility/

#
# Rules
#

define Convert_Binary
release32/$$(notdir $(1)): $(1)
	$$(call checkdir,$$@)
	$(ECHO_CMD)cp -f $$^ $$@ ; \
	$(STAB2CV) $$@
endef

define Copy_Binary
release32/$$(notdir $(1)): $(1)
	$$(call checkdir,$$@)
	$(ECHO_CMD)cp -f $$^ $$@
endef

define Copy_Docs
release32/$(1): $(DOCDIR)/$(1)
	$$(call checkdir,$$@)
	cp -f $$^ $$(dir $$@)
	$(ECHO_CMD)cp -f $$^ $$(dir $$@)
endef

define Copy_Licenses
release32/$$(notdir $(1)): $(1)
	$$(call checkdir,$$@)
	$(ECHO_CMD)cp -f $$^ $$(dir $$@)
endef

$(foreach file,$(addprefix $(DEPKGS)/bin/, $(DEPKGS_BINARIES)),$(eval $(call Convert_Binary,$(file))))

$(foreach file,$(addprefix $(DEPKGS)/bin/, $(NONGCC_BINARIES)),$(eval $(call Copy_Binary,$(file))))

$(foreach file,$(addprefix $(DEPKGS)/lib/, $(NONGCC_LIBRARIES)),$(eval $(call Copy_Binary,$(file))))

$(foreach file,$(addprefix $(BINDIR)/, $(BACULA_BINARIES)),$(eval $(call Convert_Binary,$(file))))

$(foreach file,$(addprefix $(DEPKGS)/ssl/, $(SSL_FILES)),$(eval $(call Copy_Binary,$(file))))

$(foreach file,$(addprefix ../scripts/, $(SCRIPT_FILES)),$(eval $(call Copy_Binary,$(file))))

$(foreach file,$(addprefix ../cats/, $(CAT_FILES)),$(eval $(call Copy_Binary,$(file))))

$(foreach file,$(addprefix ../../dird/, $(DIRD_FILES)),$(eval $(call Copy_Binary,$(file))))

$(foreach file,$(addprefix $(MAINDIR)/, $(LICENSE_FILES)),$(eval $(call Copy_Licenses,$(file))))

#$(foreach file,$(DOC_FILES),$(eval $(call Copy_Docs,$(file))))


$(INSTALL_EXE): winbacula.nsi $(addprefix release32/,$(BACULA_BINARIES) $(SCRIPT_FILES) $(CAT_FILES) $(DEPKGS_BINARIES) $(NONGCC_BINARIES) $(NONGCC_LIBRARIES) $(MINGW_BINARIES) $(SSL_FILES) $(DIRD_FILES) $(LICENSE_FILES) )
	echo "makensis -V3 $(DEFINES) winbacula.nsi"
	makensis -V3 $(DEFINES) winbacula.nsi

include $(BUILDDIR)/Makefile.rules

=== src/win32/win64_installer/Makefile ===
#
# Makefile for win32 bacula executables
# Using MinGW cross-compiler on GNU/Linux
#
#  Written by Eric Bollengier, March 2009 
#    based on work by Robert Nelson
#

include ../Makefile.inc

VERSION := $(shell sed -ne 's/^.define[ \t]VERSION[ \t][ \t]*"\(.*\)"/\1/p' < ../../version.h)
RELEASE ?= $(shell awk '/define RELEASE [0-9]+/ { print $$3 }' ../../version.h)

DEFINES := \
	-DVERSION=$(VERSION) \
	-DOUT_DIR=$(BUILDDIR)/release64 \
	-DSRC_DIR=release64 \
	-DSRC64_DIR=$(BUILDDIR)/win64_installer/release64 \
	-DSRC32_DIR=$(BUILDDIR)/win32_installer/release32 \
	-DWINVER=64 \
	-DBUILD_TOOLS=MinGW64 \
	-DBUILD_BAT=$(BUILD_BAT)

INSTALL_EXE := $(BUILDDIR)/release64/winbacula-$(VERSION).exe

BACULABINARIES := \
	bacula.dll \
	alldrives-fd.dll \
	exchange-fd.dll \
	bsleep.exe \
	bsmtp.exe \
	bconsole.exe \
	bacula-fd.exe \
	bacula-sd.exe \
	bextract.exe \
	bls.exe \
	bcopy.exe

DEPKGS_BINARIES := \
	openssl.exe \
	sed.exe \
	expr64.exe \
	snooze.exe \
	QtCore4.dll \
	QtGui4.dll  \
	pthreadGCE2.dll \
	libwinpthread-1.dll \
	libgcc_s_seh-1.dll \
	libstdc++-6.dll \
	libeay32.dll \
	ssleay32.dll \
	zlib1.dll

#	libgcc_s_dw2-1.dll

NONGCC_BINARIES := \
	libmysql.dll

NONGCC_LIBRARIES := \
	libpq.dll

MINGW_BINARIES := 

SCRIPT_FILES := \
	mtx-changer.cmd \
	disk-changer.cmd \
	dvd-handler.cmd

CAT_FILES := \
	create_mysql_database.cmd \
	drop_mysql_database.cmd \
	make_mysql_tables.cmd \
	make_mysql_tables.sql \
	drop_mysql_tables.cmd \
	drop_mysql_tables.sql \
	grant_mysql_privileges.cmd \
	grant_mysql_privileges.sql \
	make_mysql_catalog_backup.cmd \
	create_postgresql_database.cmd \
	create_postgresql_database.sql \
	drop_postgresql_database.cmd \
	make_postgresql_tables.cmd \
	make_postgresql_tables.sql \
	drop_postgresql_tables.cmd \
	drop_postgresql_tables.sql \
	grant_postgresql_privileges.cmd \
	grant_postgresql_privileges.sql \
	make_postgresql_catalog_backup.cmd \
	create_sqlite3_database.cmd \
	drop_sqlite3_database.cmd \
	make_sqlite3_tables.cmd \
	make_sqlite3_tables.sql \
	drop_sqlite3_tables.cmd \
	grant_sqlite3_privileges.cmd \
	make_sqlite3_catalog_backup.cmd \
	delete_catalog_backup.cmd

DIRD_FILES := \
	query.sql

SSL_FILES := \
	openssl.cnf

LICENSE_FILES := \
	LICENSE

ifeq ($(bat),no)
	BACULA_BINARIES=$(BACULABINARIES)
	HELP=
else
	BACULA_BINARIES=$(BACULABINARIES) bat.exe bacula-tray-monitor.exe
	HELP=help
endif


EXTRA=

##########################################################################

# Targets

.PHONY: all clean installer distclean

all:		$(HELP) docs $(INSTALL_EXE) $(EXTRA)

installer:	$(HELP) docs $(INSTALL_EXE)

distclean: clean

clean:
	@echo "Cleaning `pwd`"
	$(CMD_ECHO)-rm -f $(INSTALL_EXE)
	$(CMD_ECHO)-rm -rf release64

help:
	rm -rf release64/help
	mkdir -p release64/help
	cp -f $(BINDIR)/help/* release64/help/

docs:
	rm -rf release64/docs
	mkdir -p release64/docs/manuals/en/console
	mkdir -p release64/docs/manuals/en/main
	mkdir -p release64/docs/manuals/en/misc
	mkdir -p release64/docs/manuals/en/problems
	mkdir -p release64/docs/manuals/en/utility
	cp -f $(DOCDIR)/docs/manuals/en/pdf-and-html/console/console.pdf release64/docs/manuals/en/console/
	cp -f $(DOCDIR)/docs/manuals/en/pdf-and-html/main/main.pdf release64/docs/manuals/en/main/
	cp -f $(DOCDIR)/docs/manuals/en/pdf-and-html/misc/misc.pdf release64/docs/manuals/en/misc/
	cp -f $(DOCDIR)/docs/manuals/en/pdf-and-html/problems/problems.pdf release64/docs/manuals/en/problems/
	cp -f $(DOCDIR)/docs/manuals/en/pdf-and-html/utility/utility.pdf release64/docs/manuals/en/utility/

#
# Rules
#

define Convert_Binary
release64/$$(notdir $(1)): $(1)
	$$(call checkdir,$$@)
	$(ECHO_CMD)cp -f $$^ $$@
endef

define Copy_Binary
release64/$$(notdir $(1)): $(1)
	$$(call checkdir,$$@)
	$(ECHO_CMD)cp -f $$^ $$@
endef

define Copy_Docs
release64/$(1): $(DOCDIR)/$(1)
	$$(call checkdir,$$@)
	$(ECHO_CMD)cp -f $$^ $$(dir $$@)
endef

define Copy_Licenses
release64/$$(notdir $(1)): $(1)
	$$(call checkdir,$$@)
	$(ECHO_CMD)cp -f $$^ $$(dir $$@)
endef

$(foreach file,$(addprefix $(DEPKGS)/bin/, $(DEPKGS_BINARIES)),$(eval $(call Convert_Binary,$(file))))

$(foreach file,$(addprefix $(DEPKGS)/bin/, $(NONGCC_BINARIES)),$(eval $(call Copy_Binary,$(file))))

$(foreach file,$(addprefix $(DEPKGS)/lib/, $(NONGCC_LIBRARIES)),$(eval $(call Copy_Binary,$(file))))

$(foreach file,$(addprefix $(BINDIR)/, $(BACULA_BINARIES)),$(eval $(call Convert_Binary,$(file))))

$(foreach file,$(addprefix $(MINGW_DLLDIR)/, $(MINGW_BINARIES)),$(eval $(call Copy_Binary,$(file))))

$(foreach file,$(addprefix $(DEPKGS)/ssl/, $(SSL_FILES)),$(eval $(call Copy_Binary,$(file))))

$(foreach file,$(addprefix ../scripts/, $(SCRIPT_FILES)),$(eval $(call Copy_Binary,$(file))))

$(foreach file,$(addprefix ../cats/, $(CAT_FILES)),$(eval $(call Copy_Binary,$(file))))

$(foreach file,$(addprefix ../../dird/, $(DIRD_FILES)),$(eval $(call Copy_Binary,$(file))))

$(foreach file,$(addprefix $(MAINDIR)/, $(LICENSE_FILES)),$(eval $(call Copy_Licenses,$(file))))

#$(foreach file,$(DOC_FILES),$(eval $(call Copy_Docs,$(file))))

$(INSTALL_EXE): winbacula.nsi $(addprefix release64/,$(BACULA_BINARIES) $(DEPKGS_BINARIES) $(SSL_FILES) $(LICENSE_FILES))
	makensis -V3 $(DEFINES) winbacula.nsi
	echo " "

include $(BUILDDIR)/Makefile.rules

=== debian/changelog ===
bacula (9.6.7-7) unstable; urgency=medium

  * Reupload with additional old form of one lintian override to pass
    ftp-master checks

 -- Carsten Leonhardt <leo@debian.org>  Tue, 07 Feb 2023 21:51:52 +0100

bacula (9.6.7-6) unstable; urgency=medium

  [ Sven Hartge ]
  * Fix lintian overrides to use correct tags

  [Helmut Grohne]
  * Fix finding libmysqlclient when cross building (Closes: #1019395)

  [ Carsten Leonhardt ]
  * Add configuration to needrestart so that Bacula daemons are not
    restarted by default, preventing the interruption of backup runs
  * Update Standards-Version to 4.6.2, no changes required.

 -- Carsten Leonhardt <leo@debian.org>  Tue, 07 Feb 2023 17:56:26 +0100

bacula (9.6.7-5) unstable; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster

  [ Sven Hartge ]
  * Change configure.in to use AC_PATH_TOOL to fix FTCBFS (Closes: #1009012)
    Thanks to Helmut Grohne <helmut@subdivi.de> for finding and fixing
    the issue.

  [ Carsten Leonhardt ]
  * Update Standards-Version to 4.6.1, no changes required.

 -- Carsten Leonhardt <leo@debian.org>  Mon, 30 May 2022 16:41:18 +0200

bacula (9.6.7-4) unstable; urgency=medium

  [ Sven Hartge ]
  * Fix configure.in to work with autoconf2.70+ (Closes: #997139)
  * Update to Debian Policy 4.6.0, no changes needed
  * Remove code to remove UCF temp files from upgrade to 9.0.7+dfsg-2
  * Remove Lintian ignore for no longer necessary tags
  * Remove manual -Wl,--as-needed linker flag, it is the default since Bullseye
  * Add context to Lintian tags that need them
  * Remove 2 obsolete maintscript entries in 2 files.
  * Remove bacula-sd.maintscript needed for uprade from ancient version
  * Manually add changes suggested by Debian Janitor
  * Remove reminder about "as-needed" linker flag
  * Remove Homepages field from metadata, fixing Lintian warning

 -- Carsten Leonhardt <leo@debian.org>  Sat, 12 Mar 2022 10:43:43 +0100

bacula (9.6.7-3) unstable; urgency=medium

  [ Carsten Leonhardt ]
  * Update Standards-Version to 4.5.1, no changes required.

  [ Sven Hartge ]
  * Add upstream patch fixing a memory overflow access
  * Reorder patches in series to apply upstream patches first

 -- Carsten Leonhardt <leo@debian.org>  Sun, 31 Jan 2021 19:27:24 +0100

bacula (9.6.7-2) unstable; urgency=medium

  [ Carsten Leonhardt ]
  * Backport btraceback from 11.0.1 to improve btraceback output
    (Closes: #954971)

  [ Sven Hartge ]
  * Fix bug in database locking code causing concurrency problems
    and job failures by importing patch from https://bugs.gentoo.org/766195
    from Phil Stracchino <phils@caerllewys.net> and
     Martin Simmons <martin@lispworks.com>.

 -- Carsten Leonhardt <leo@debian.org>  Thu, 21 Jan 2021 23:30:02 +0100

bacula (9.6.7-1) unstable; urgency=high

  * New upstream version 9.6.7
   + Adds compatibility for MariaDB 10.5 (Closes: #975970)
   + Fixes sporadic deadlock issues with MariaDB
   + Fixes compile errors with GCC10

  [ Sven Hartge ]
  * Add rudimentary man-pages for b*json commands
  * Remove patches added upstream
   + fix-narrowing-magic-numbers
   + fix_en_AR.po_errors

  [ Debian Janitor ]
  * Fixing Lintian tags
   + Fix day-of-week for changelog entries 1.36.3-2, 1.34.6-1, 1.32f-5-3.1.
   + Use secure URI in Homepage field.

 -- Sven Hartge <sven@svenhartge.de>  Fri, 11 Dec 2020 12:46:12 +0100

bacula (9.6.6-2) unstable; urgency=medium

  [ Carsten Leonhardt ]
  * Add patch to fix errors in po/en_AR.po Although the file is unused,
    the Debian QA tools point out the issues. This is to give us peace
    of mind.

  [ Sven Hartge ]
  * Fix Bacula binaries breaking when linked with symbolic-functions by
    stripping it from LDFLAGS. (LP: #1898006)

 -- Carsten Leonhardt <leo@debian.org>  Thu, 01 Oct 2020 17:33:19 +0200

bacula (9.6.6-1) unstable; urgency=medium

  * New upstream version 9.6.6

  [ Sven Hartge ]
  * Improve maintainer scripts
  * Fix narrowing conversion of magic numbers on 32bit arches with GCC10
  * Add overrides for non-applicable and false-positive lintian tags
  * Add patch to make variables in database scripts easier to manually
    override (Closes: #971381)

  [ Carsten Leonhardt ]
  * Add "Forwarded: not-needed" header to Debian specific patches
  * Add author information on some patches
  * remove obsolete function from common-functions.init
  * Convert 8bit encoding of files to UTF-8

 -- Carsten Leonhardt <leo@debian.org>  Thu, 01 Oct 2020 00:35:27 +0200

=== debian/control ===
Source: bacula
Section: admin
Priority: optional
Maintainer: Debian Bacula Team <pkg-bacula-devel@lists.alioth.debian.org>
Uploaders: Carsten Leonhardt <leo@debian.org>
Build-Depends: autoconf,
               bc,
               debhelper-compat (= 13),
               default-libmysqlclient-dev,
               dh-exec,
               libacl1-dev,
               libcap-dev [linux-any],
               libkrb5-dev,
               liblzo2-dev,
               libpq-dev,
               libreadline-dev,
               libsqlite3-dev,
               libssl-dev,
               libwrap0-dev,
               libx11-dev,
               libxt-dev,
               mtx [!hurd-any],
               pkg-config,
               po-debconf,
               postgresql-server-dev-all,
               qtbase5-dev,
               zlib1g-dev
Standards-Version: 4.6.2
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/bacula-team/bacula
Vcs-Git: https://salsa.debian.org/bacula-team/bacula.git
Homepage: https://www.bacula.org/

Package: bacula
Architecture: all
Pre-Depends: ${misc:Pre-Depends}
Depends: bacula-client, bacula-server, ${misc:Depends}
Description: network backup service - metapackage
 Bacula is a set of programs to manage backup, recovery and verification
 of computer data across a network of computers of different kinds.
 .
 It is efficient and relatively easy to use, while offering many advanced
 storage management features that make it easy to find and recover lost or
 damaged files. Due to its modular design, Bacula is scalable from small
 single computer systems to networks of hundreds of machines.
 .
 This metapackage installs the entire suite of Bacula applications: job
 scheduling, storage control, node connector and administrative console.

Package: bacula-common
Architecture: any
Pre-Depends: adduser, ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: gdb
Description: network backup service - common support files
 Bacula is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 This package provides files that are useful for other Bacula packages.

Package: bacula-common-sqlite3
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: bacula-common, ${misc:Depends}, ${shlibs:Depends}
Conflicts: bacula-common-mysql, bacula-common-pgsql
Description: network backup service - SQLite v3 common files
 Bacula is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 This package provides files that are useful for other Bacula packages
 for the SQLite v3 database.
 .
 Please be aware that using SQLite 3 databases is no longer supported
 by the author.

Package: bacula-common-pgsql
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: bacula-common, ${misc:Depends}, ${shlibs:Depends}
Conflicts: bacula-common-mysql, bacula-common-sqlite3
Description: network backup service - PostgreSQL common files
 Bacula is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 This package provides files that are useful for other Bacula packages
 for the PostgreSQL database.

Package: bacula-common-mysql
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: bacula-common, ${misc:Depends}, ${shlibs:Depends}
Conflicts: bacula-common-pgsql, bacula-common-sqlite3
Description: network backup service - MySQL common files
 Bacula is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 This package provides files that are useful for other Bacula packages
 for the MySQL database.

Package: bacula-director
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: bacula-common (= ${binary:Version}),
         bacula-director-pgsql (= ${source:Version}) | bacula-director-mysql (= ${source:Version}) | bacula-director-sqlite3 (= ${source:Version}),
         bsd-mailx | mailx,
         sysvinit-utils (>= 3.05-1),
         ucf,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: bacula-doc
Replaces: bacula-common (<< 9.6.4-1)
Breaks: bacula-common (<< 9.6.4-1)
Description: network backup service - Director daemon
 Bacula is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 The Bacula Director service supervises all the backup, restore, verify and
 archive operations. It can run as a daemon or as a foreground service which
 administrators can use to schedule backups and recover files.
 .
 This package provides the Bacula Director daemon.

Package: bacula-director-sqlite3
Architecture: all
Pre-Depends: ${misc:Pre-Depends}
Depends: bacula-common-sqlite3 (<< ${source:Version}.1~),
         bacula-common-sqlite3 (>= ${source:Version}),
         dbconfig-sqlite3 | dbconfig-no-thanks,
         file,
         sqlite3,
         ${misc:Depends}
Conflicts: bacula-director-database
Provides: bacula-director-database
Replaces: bacula-director-database
Suggests: gawk, ${perl:Depends}
Description: network backup service - SQLite 3 storage for Director
 Bacula is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 The Bacula Director service supervises all the backup, restore, verify and
 archive operations. It can run as a daemon or as a foreground service which
 administrators can use to schedule backups and recover files.
 .
 This package stores Bacula's catalog in an SQLite 3 database and thus is
 only suitable for small or test installations.
 .
 Please be aware that using SQLite 3 databases is no longer supported
 by the author.

Package: bacula-director-mysql
Architecture: all
Pre-Depends: ${misc:Pre-Depends}
Depends: bacula-common-mysql (<< ${source:Version}.1~),
         bacula-common-mysql (>= ${source:Version}),
         dbconfig-mysql | dbconfig-no-thanks,
         default-mysql-client | virtual-mysql-client,
         ${misc:Depends}
Conflicts: bacula-director-database
Provides: bacula-director-database
Replaces: bacula-director-database
Recommends: default-mysql-server | virtual-mysql-server
Suggests: gawk, ${perl:Depends}
Description: network backup service - MySQL storage for Director
 Bacula is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 The Bacula Director service supervises all the backup, restore, verify and
 archive operations. It can run as a daemon or as a foreground service which
 administrators can use to schedule backups and recover files.
 .
 This package stores Bacula's catalog in a MySQL database and thus is
 suitable for medium-sized installations.

Package: bacula-director-pgsql
Architecture: all
Pre-Depends: ${misc:Pre-Depends}
Depends: bacula-common-pgsql (<< ${source:Version}.1~),
         bacula-common-pgsql (>= ${source:Version}),
         dbconfig-pgsql | dbconfig-no-thanks,
         postgresql-client,
         ${misc:Depends}
Conflicts: bacula-director-database
Provides: bacula-director-database
Replaces: bacula-director-database
Recommends: postgresql
Suggests: gawk, ${perl:Depends}
Description: network backup service - PostgreSQL storage for Director
 Bacula is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 The Bacula Director service supervises all the backup, restore, verify and
 archive operations. It can run as a daemon or as a foreground service which
 administrators can use to schedule backups and recover files.
 .
 This package stores Bacula's catalog in a PostgreSQL database and thus is
 suited for large installations.

Package: bacula-client
Architecture: all
Pre-Depends: ${misc:Pre-Depends}
Depends: bacula-console (>= ${source:Version}),
         bacula-fd (>= ${source:Version}),
         ${misc:Depends}
Description: network backup service - client metapackage
 Bacula is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 The Bacula Director service supervises all the backup, restore, verify and
 archive operations. It can run as a daemon or as a foreground service which
 administrators can use to schedule backups and recover files.
 .
 The package is a metapackage for client installations (file daemon and
 console only).

Package: bacula-fd
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: bacula-common (= ${binary:Version}),
         sysvinit-utils (>= 3.05-1),
         ucf,
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: bacula-common (<< 9.6.4-1)
Breaks: bacula-common (<< 9.6.4-1)
Description: network backup service - file daemon
 Bacula is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 The file daemon has to be installed on the machine to be backed up. It is
 responsible for providing the file attributes and data when requested by
 the Director and also for the file system-dependent part of restoration.

Package: bacula-server
Architecture: all
Pre-Depends: ${misc:Pre-Depends}
Depends: bacula-bscan (>= ${source:Version}),
         bacula-director (>= ${source:Version}),
         bacula-sd (>= ${source:Version}),
         ${misc:Depends}
Recommends: bacula-fd
Description: network backup service - server metapackage
 Bacula is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 This metapackage provides a standard server install, consisting of the
 director and storage daemons.

Package: bacula-sd
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: bacula-common (= ${binary:Version}),
         sysvinit-utils (>= 3.05-1),
         mtx [!hurd-any],
         ucf,
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: bacula-common (<< 9.6.4-1),
          bacula-sd-mysql (<< 7.4.3+dfsg-3),
          bacula-sd-pgsql (<< 7.4.3+dfsg-3),
          bacula-sd-sqlite3 (<< 7.4.3+dfsg-3)
Breaks: bacula-common (<< 9.6.4-1),
        bacula-sd-mysql (<< 7.4.3+dfsg-3),
        bacula-sd-pgsql (<< 7.4.3+dfsg-3),
        bacula-sd-sqlite3 (<< 7.4.3+dfsg-3)
Recommends: bacula-bscan, mt-st
Suggests: dds2tar, scsitools, sg3-utils
Description: network backup service - storage daemon
 Bacula is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 The storage daemon performs the storage and recovery of the file
 attributes and data to the physical media; in other words, it is
 responsible for reading and writing the backups.
 .
 It runs on the machine which has access to the backup device(s) - usually
 a tape drive, but alternatively other storage media, such as files.

Package: bacula-bscan
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: bacula-common-pgsql (= ${binary:Version}) | bacula-common-mysql (= ${binary:Version}) | bacula-common-sqlite3 (= ${binary:Version}),
         bacula-sd (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: bacula-sd-mysql (<< 7.4.3+dfsg-3),
          bacula-sd-pgsql (<< 7.4.3+dfsg-3),
          bacula-sd-sqlite3 (<< 7.4.3+dfsg-3)
Breaks: bacula-sd-mysql (<< 7.4.3+dfsg-3),
        bacula-sd-pgsql (<< 7.4.3+dfsg-3),
        bacula-sd-sqlite3 (<< 7.4.3+dfsg-3)
Description: network backup service - bscan tool
 Bacula is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 The storage daemon performs the storage and recovery of the file
 attributes and data to the physical media; in other words, it is
 responsible for reading and writing the backups.
 .
 This package contains the bscan utility, which is used for recovery
 when Bacula's catalog is unavailable.

Package: bacula-console

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

# enable bindnow
# https://wiki.debian.org/HardeningWalkthrough
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Bacula binaries break if linked with symbolic-functions
# https://bugs.bacula.org/view.php?id=2557
# Debian does not (yet) use this, but Ubuntu does. Help them out by
# stripping the flag from LDFLAGS
# https://bugs.launchpad.net/ubuntu/+source/bacula/+bug/1898006
export DEB_LDFLAGS_MAINT_STRIP = -Wl,-Bsymbolic-functions

# Make qtchooser select Qt5
export QT_SELECT=qt5

DEB_HOST_ARCH_OS    ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)

VARIANTS := pgsql mysql sqlite3
VERSION := $(shell sed -n -e 's/^\#define VERSION.*"\(.*\)"$$/\1/p' src/version.h)

######################################################################

DBC := usr/share/dbconfig-common/data/

CONF_ALL	= \
	--enable-smartalloc \
	--with-tcp-wrappers \
	--with-openssl \
	--with-libiconv-prefix=/usr/include \
	--with-readline=/usr/include/readline \
	--disable-conio \
	--with-libintl-prefix=/usr/include \
	--docdir=\$${prefix}/share/doc/bacula-common \
	--htmldir=\$${prefix}/share/doc/bacula-common/html \
	--libdir=\$${prefix}/lib/bacula \
	--enable-batch-insert \
	--enable-ipv6 \
	--with-dir-password=XXX_DIRPASSWORD_XXX \
	--with-fd-password=XXX_FDPASSWORD_XXX \
	--with-sd-password=XXX_SDPASSWORD_XXX \
	--with-mon-dir-password=XXX_MONDIRPASSWORD_XXX \
	--with-mon-fd-password=XXX_MONFDPASSWORD_XXX \
	--with-mon-sd-password=XXX_MONSDPASSWORD_XXX \
	--with-db-name=XXX_DBNAME_XXX \
	--with-db-user=XXX_DBUSER_XXX \
	--with-db-password=XXX_DBPASSWORD_XXX \
	--with-hostname=localhost \
	--config-cache \
	--with-archivedir=/nonexistant/path/to/file/archive/dir \
	--sysconfdir=/etc/bacula \
	--with-scriptdir=/etc/bacula/scripts \
	--sharedstatedir=/var/lib/bacula \
	--localstatedir=/var/lib/bacula \
	--with-logdir=/var/log/bacula \
	--with-pid-dir=/run/bacula \
	--with-smtp-host=localhost \
	--with-working-dir=/var/lib/bacula \
	--with-subsys-dir=/run/lock \
	--with-dump-email=root \
	--with-job-email=root \
	--with-mysql --with-postgresql --with-sqlite3 \
	--enable-bat --with-x \
	--disable-s3

ifeq ($(DEB_HOST_ARCH_OS),linux)
CONF_ALL	+= --with-systemd=/lib/systemd/system
endif

ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
CONF_ALL	+= --disable-acl --disable-xattr
endif

ifeq ($(DEB_HOST_ARCH_OS),hurd)
CONF_ALL       += --disable-acl --disable-xattr
endif

#set to 1 if configured with systemd
HAVE_SYSTEMD = $(findstring 1,$(shell egrep "^\#define HAVE_SYSTEMD" config.log))

LONGNAME_mysql		= mysql
LONGNAME_pgsql		= postgresql
LONGNAME_sqlite3	= sqlite3

###########################################################################

# Macro for generate file for specified database from specified template
# args: 1 -- template file
#       2 -- db type
define template-subst
sed -e 's/XX_DB_XX/$(2)/' -e 's/XX_DBLONGNAME_XX/$(LONGNAME_$(2))/' -e 's/XX_VERSION_XX/$(VERSION)/' '$(1)' >'$(patsubst %.in,%,$(subst -db.,-$(2).,$(1)))';
endef

# Macro for cleanup file generated for specified database from specified template
# args: 1 -- template file
#       2 -- db type
define template-cleanup
rm -f '$(patsubst %.in,%,$(subst -db.,-$(2).,$(1)))';
endef

# Macro for generate from all templates files for specified database
# args: 1 -- db type
define db-templates-subst
$(foreach template,$(wildcard debian/*-db.*.in),$(call template-subst,$(template),$(1)))
endef

# Macro for cleanup all files generated for specified database from templates
# args: 1 -- db type
define db-templates-cleanup
$(foreach template,$(wildcard debian/*-db.*.in),$(call template-cleanup,$(template),$(1)))
endef

%:
	dh $@

# For packages depending on bacula-director-DBTYPE, we handle the
# dependencies on that ourselves, because dpkg-shlibdeps doesn't
# understand the variants
override_dh_shlibdeps:
	dh_shlibdeps -pbacula-bscan -pbacula-director -- -xbacula-common-mysql -xbacula-common-pgsql -xbacula-common-sqlite3
	dh_shlibdeps -a --remaining-packages

override_dh_auto_build-arch:
	dh_auto_build -a
# also build the monitoring plugin from the examples
	make -C examples/nagios/check_bacula

override_dh_auto_install-arch:
	dh_auto_install -a

override_dh_install-arch:
# sd plugins aren't installed automatically
#	make DESTDIR=$(CURDIR)/debian/tmp -C src/stored install-aligned install-cloud
	dh_install -a
	# create a reference of which database type is installed on the system
	# and create a link to the dbconfig information that is dbtype independent
	$(foreach db,$(VARIANTS), \
		mkdir -p debian/bacula-common-$(db)/usr/share/bacula-common; \
		echo $(db) > debian/bacula-common-$(db)/usr/share/bacula-common/dbtype; \
		ln -s /etc/dbconfig-common/bacula-director-$(db).conf debian/bacula-common-$(db)/usr/share/bacula-common/dbc_database.conf;)
ifeq ($(HAVE_SYSTEMD),1)
	# only install systemd related files if systemd is enabled during build
	install -m 644 platforms/systemd/bacula.conf -D debian/bacula-common/usr/lib/tmpfiles.d/bacula.conf
	install -m 644 platforms/systemd/bacula-fd.service -D debian/bacula-fd/lib/systemd/system/bacula-fd.service
	install -m 644 platforms/systemd/bacula-sd.service -D debian/bacula-sd/lib/systemd/system/bacula-sd.service
	install -m 644 platforms/systemd/bacula-dir.service -D debian/bacula-director/lib/systemd/system/bacula-director.service
endif

override_dh_installexamples:
# The monitoring plugin in the examples needs to be cleaned, otherwise
# builds will not be reproducible. But only if the makefile exists,
# which it doesn't if we only build-indep.
	@[ -f examples/nagios/check_bacula/Makefile ] && make -C examples/nagios/check_bacula libtool-clean distclean || true
	# unfitting permissions reported as https://bugs.bacula.org/view.php?id=2445
	chmod 644 examples/autochangers/mtx-changer.Adic-Scalar-100
	dh_installexamples

override_dh_installdocs:
	cp -a ReleaseNotes NEWS
	dh_installdocs -pbacula --link-doc=bacula-server
	dh_installdocs -Nbacula-common -Nbacula-client -Nbacula-server -Nbacula-director-mysql -Nbacula-director-sqlite3 -Nbacula-director-pgsql --remaining-packages --link-doc=bacula-common
	dh_installdocs --remaining-packages

# We only need the scripts from src/cats for the arch:all packages.
# Compiling and installing is easier than picking out the scripts to
# install manually
override_dh_auto_build-indep:
	make DESTDIR=$(CURDIR)/debian/tmp -C src/cats
override_dh_auto_install-indep:
	mkdir -p debian/tmp/etc/bacula/scripts
	make DESTDIR=$(CURDIR)/debian/tmp -C src/cats install
	######### dbconfig-common stuff
	# The script install-dbconfig needs to be adapted when upstream changes the database format!
	debian/scripts/install-dbconfig # handles install of all upgrade/install scripts to db version 11 and greater

override_dh_missing:
	dh_missing --list-missing

override_dh_autoreconf:
	dh_autoreconf debian/autogen.sh

override_dh_auto_configure:
	$(foreach db,$(VARIANTS),$(call db-templates-subst,$(db)))
	# Strange workaround for strange binary path problems in Qt5.9
	# https://gitweb.gentoo.org/repo/gentoo.git/tree/app-backup/bacula/bacula-9.0.6-r2.ebuild?id=9b8f311cb9d88f02bebc4bfb51282db4457f87d7#n166
	mkdir -p src/qt-console/.libs
	touch src/qt-console/.libs/bat
	chmod 755 src/qt-console/.libs/bat
#
	mkdir -p src/qt-console/tray-monitor/.libs
	touch src/qt-console/tray-monitor/.libs/bacula-tray-monitor
	chmod 755 src/qt-console/tray-monitor/.libs/bacula-tray-monitor
#
	dh_auto_configure -- $(CONF_ALL)
	debian/scripts/generate-doc-dir-to-symlink-migration create
	debian/scripts/autopostrm create

override_dh_makeshlibs:
	dh_makeshlibs -n -Xbpipe-fd.so
	# fix shlibs for bacula-common-*
	$(foreach db,$(VARIANTS), sed -i 's/libbaccats-[a-z0-9]*/libbaccats/' debian/bacula-common-$(db)/DEBIAN/shlibs;)

override_dh_clean:
	$(foreach db,$(VARIANTS),$(call db-templates-cleanup,$(db)))
	dh_clean
	debian/scripts/generate-doc-dir-to-symlink-migration clean
	debian/scripts/autopostrm clean
	rm -f NEWS

override_dh_auto_test:

=== debian/tests/control ===
Tests: backup-test-pgsql, program-test-pgsql
Restrictions: breaks-testbed needs-root allow-stderr
Depends: bacula, bacula-director-pgsql, postgresql

Tests: backup-test-mysql, program-test-mysql
Restrictions: breaks-testbed needs-root allow-stderr
Depends: bacula,
         bacula-director-mysql,
         default-mysql-server | virtual-mysql-server

Tests: backup-test-sqlite3, program-test-sqlite3
Restrictions: breaks-testbed needs-root allow-stderr
Depends: bacula, bacula-director-sqlite3
